console.log("mapStyling loaded")

function onMarkerTemplate(o, e) {
    //console.log("Map onMarkerTemplate " + e);

    return {
        measure: function (measureInfo) {
            var cont = measureInfo.context;
            var data = measureInfo.data;
            var code = "null";
            if (data.item != null) {
                // using Code from DBF file
                code = data.item.getFieldValue("Code").toString();
            }
            var height = cont.measureText("M").width;
            var width = cont.measureText(code).width;
            measureInfo.width  = width;
            measureInfo.height = height;
        },

        render: function (renderInfo) {
            //console.log("mapStyling onMarkerTemplate render ");
            var ctx = renderInfo.context;
            if (renderInfo.isHitTestRender) {
                ctx.fillStyle = renderInfo.data.actualItemBrush.fill;
            } else {
                ctx.fillStyle = "black";
            }

            var halfWidth  = renderInfo.availableWidth / 2.0;
            var halfHeight = renderInfo.availableHeight / 2.0; 

            var cx = renderInfo.xPosition;
            var cy = renderInfo.yPosition;

            var x = renderInfo.xPosition - halfWidth;
            var y = renderInfo.yPosition - (halfHeight);
 
            if (renderInfo.isHitTestRender) {
                ctx.fillRect(x, y, renderInfo.availableWidth, renderInfo.availableHeight);
            } else { 

                ctx.fillStyle = "#3399D9";
                ctx.fillRect(x - 2, cy - 2, renderInfo.availableWidth + 4, renderInfo.availableHeight + 4);

                ctx.lineWidth = 0.5;
                ctx.strokeStyle = "#0285D6"; 
                ctx.strokeRect(x - 2, cy - 2, renderInfo.availableWidth + 4, renderInfo.availableHeight + 4); 

                var data = renderInfo.data;
                var code = data.item.getFieldValue("Code").toString();
                ctx.font = "bold 8px Verdana";
                ctx.textAlign = "center";
                ctx.textBaseline = "top";
                ctx.fillStyle = "#EEEEEE";
                ctx.fillText(code, cx, cy);
            }
        }
    }
}
 
igRegisterScript("onMarkerTemplate", onMarkerTemplate, true);
 